-- VHDL model created from dragonflybackup.sch - Mon Feb 25 16:21:58 2002


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity dragonflybackup is
   port ( aspetta   : in    std_logic; 
          clk       : in    std_logic; 
          Coef_im   : in    std_logic_vector (8 downto 0); 
          Coef_re   : in    std_logic_vector (8 downto 0); 
          Dato1_im  : in    std_logic_vector (8 downto 0); 
          Dato1_re  : in    std_logic_vector (8 downto 0); 
          Dato2_im  : in    std_logic_vector (8 downto 0); 
          Dato2_re  : in    std_logic_vector (8 downto 0); 
          pos       : in    std_logic; 
          registra  : in    std_logic; 
          registra2 : in    std_logic; 
          tronca    : in    std_logic; 
          a         : out   std_logic_vector (8 downto 0); 
          b         : out   std_logic_vector (8 downto 0); 
          c         : out   std_logic_vector (8 downto 0); 
          d         : out   std_logic_vector (8 downto 0); 
          prendi    : out   std_logic);
end dragonflybackup;

architecture BEHAVIORAL of dragonflybackup is
   attribute BOX_TYPE   : STRING ;
   signal aireg     : std_logic_vector (8 downto 0);
   signal alto      : std_logic;
   signal clkIM     : std_logic;
   signal clkRE     : std_logic;
   signal clkr1     : std_logic;
   signal clkr2     : std_logic;
   signal doposomma : std_logic_vector (8 downto 0);
   signal d1_im     : std_logic_vector (8 downto 0);
   signal d1_re     : std_logic_vector (8 downto 0);
   signal IM        : std_logic_vector (8 downto 0);
   signal im2       : std_logic_vector (8 downto 0);
   signal ing_mult  : std_logic_vector (8 downto 0);
   signal inverti   : std_logic;
   signal muxcoef   : std_logic;
   signal muxdato1  : std_logic;
   signal RE        : std_logic_vector (8 downto 0);
   signal re2       : std_logic_vector (8 downto 0);
   signal r1        : std_logic_vector (8 downto 0);
   signal r2        : std_logic_vector (8 downto 0);
   signal terra     : std_logic;
   signal XLXN_2    : std_logic_vector (8 downto 0);
   component mpy9signed
      port ( b       : in    std_logic_vector (8 downto 0); 
             a       : in    std_logic_vector (8 downto 0); 
             pos     : in    std_logic; 
             inverti : in    std_logic; 
             uscita  : out   std_logic_vector (8 downto 0));
   end component;
   
   component mux18x9
      port ( seleziona : in    std_logic; 
             a         : in    std_logic_vector (8 downto 0); 
             b         : in    std_logic_vector (8 downto 0); 
             c         : out   std_logic_vector (8 downto 0));
   end component;
   
   component somma
      port ( a      : in    std_logic_vector (8 downto 0); 
             b      : in    std_logic_vector (8 downto 0); 
             sub    : in    std_logic; 
             tronca : in    std_logic; 
             s      : out   std_logic_vector (8 downto 0));
   end component;
   
   component flowlogic
      port ( aspetta  : in    std_logic; 
             clk      : in    std_logic; 
             muxcoef  : out   std_logic; 
             muxdato1 : out   std_logic; 
             clkr1    : out   std_logic; 
             inverti  : out   std_logic; 
             clkr2    : out   std_logic; 
             prendi   : out   std_logic; 
             clkRE    : out   std_logic; 
             clkIM    : out   std_logic);
   end component;
   
   component regvhdl
      port ( clk : in    std_logic; 
             mem : in    std_logic; 
             a   : in    std_logic_vector (8 downto 0); 
             b   : out   std_logic_vector (8 downto 0));
   end component;
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : COMPONENT is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : COMPONENT is "BLACK_BOX";
   
begin
   XLXI_8 : mpy9signed
      port map (a(8 downto 0)=>ing_mult(8 downto 0), b(8 downto 0)=>XLXN_2(8
            downto 0), inverti=>inverti, pos=>pos, uscita(8 downto 0)=>aireg(8
            downto 0));
   
   XLXI_9 : mux18x9
      port map (a(8 downto 0)=>d1_re(8 downto 0), b(8 downto 0)=>d1_im(8 downto
            0), seleziona=>muxdato1, c(8 downto 0)=>XLXN_2(8 downto 0));
   
   XLXI_10 : mux18x9
      port map (a(8 downto 0)=>Coef_re(8 downto 0), b(8 downto 0)=>Coef_im(8
            downto 0), seleziona=>muxcoef, c(8 downto 0)=>ing_mult(8 downto 0));
   
   XLXI_34 : somma
      port map (a(8 downto 0)=>r1(8 downto 0), b(8 downto 0)=>r2(8 downto 0),
            sub=>terra, tronca=>tronca, s(8 downto 0)=>doposomma(8 downto 0));
   
   XLXI_48 : flowlogic
      port map (aspetta=>aspetta, clk=>clk, clkIM=>clkIM, clkRE=>clkRE,
            clkr1=>clkr1, clkr2=>clkr2, inverti=>inverti, muxcoef=>muxcoef,
            muxdato1=>muxdato1, prendi=>prendi);
   
   XLXI_53 : regvhdl
      port map (a(8 downto 0)=>Dato2_re(8 downto 0), clk=>clk, mem=>registra2,
            b(8 downto 0)=>re2(8 downto 0));
   
   XLXI_54 : regvhdl
      port map (a(8 downto 0)=>Dato2_im(8 downto 0), clk=>clk, mem=>registra2,
            b(8 downto 0)=>im2(8 downto 0));
   
   XLXI_55 : regvhdl
      port map (a(8 downto 0)=>aireg(8 downto 0), clk=>clk, mem=>clkr2, b(8
            downto 0)=>r2(8 downto 0));
   
   XLXI_56 : regvhdl
      port map (a(8 downto 0)=>aireg(8 downto 0), clk=>clk, mem=>clkr1, b(8
            downto 0)=>r1(8 downto 0));
   
   XLXI_57 : regvhdl
      port map (a(8 downto 0)=>doposomma(8 downto 0), clk=>clk, mem=>clkRE, b(8
            downto 0)=>RE(8 downto 0));
   
   XLXI_58 : regvhdl
      port map (a(8 downto 0)=>doposomma(8 downto 0), clk=>clk, mem=>clkIM, b(8
            downto 0)=>IM(8 downto 0));
   
   XLXI_66 : somma
      port map (a(8 downto 0)=>re2(8 downto 0), b(8 downto 0)=>RE(8 downto 0),
            sub=>terra, tronca=>terra, s(8 downto 0)=>a(8 downto 0));
   
   XLXI_67 : somma
      port map (a(8 downto 0)=>im2(8 downto 0), b(8 downto 0)=>IM(8 downto 0),
            sub=>terra, tronca=>terra, s(8 downto 0)=>b(8 downto 0));
   
   XLXI_68 : somma
      port map (a(8 downto 0)=>re2(8 downto 0), b(8 downto 0)=>RE(8 downto 0),
            sub=>alto, tronca=>terra, s(8 downto 0)=>c(8 downto 0));
   
   XLXI_69 : somma
      port map (a(8 downto 0)=>im2(8 downto 0), b(8 downto 0)=>IM(8 downto 0),
            sub=>alto, tronca=>terra, s(8 downto 0)=>d(8 downto 0));
   
   XLXI_70 : VCC
      port map (P=>alto);
   
   XLXI_71 : GND
      port map (G=>terra);
   
   XLXI_75 : regvhdl
      port map (a(8 downto 0)=>Dato1_re(8 downto 0), clk=>clk, mem=>registra,
            b(8 downto 0)=>d1_re(8 downto 0));
   
   XLXI_76 : regvhdl
      port map (a(8 downto 0)=>Dato1_im(8 downto 0), clk=>clk, mem=>registra,
            b(8 downto 0)=>d1_im(8 downto 0));
   
end BEHAVIORAL;


