-- VHDL model created from flow.sch - Mon Feb 25 16:22:01 2002


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity flow is
   port ( aspetta : in    std_logic; 
          clk     : in    std_logic; 
          s       : out   std_logic_vector (7 downto 1));
end flow;

architecture BEHAVIORAL of flow is
   attribute INIT       : STRING ;
   attribute BOX_TYPE   : STRING ;
   signal XLXN_13 : std_logic;
   signal XLXN_14 : std_logic;
   signal s_DUMMY : std_logic_vector (7 downto 1);
   component FDR
      -- synopsys translate_off
      generic( INIT : bit :=  '0');
      -- synopsys translate_on
      port ( C : in    std_logic; 
             D : in    std_logic; 
             R : in    std_logic; 
             Q : out   std_logic);
   end component;
   attribute INIT of FDR : COMPONENT is "0";
   attribute BOX_TYPE of FDR : COMPONENT is "BLACK_BOX";
   
   component FDP
      -- synopsys translate_off
      generic( INIT : bit :=  '1');
      -- synopsys translate_on
      port ( C   : in    std_logic; 
             D   : in    std_logic; 
             PRE : in    std_logic; 
             Q   : out   std_logic);
   end component;
   attribute INIT of FDP : COMPONENT is "1";
   attribute BOX_TYPE of FDP : COMPONENT is "BLACK_BOX";
   
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : COMPONENT is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : COMPONENT is "BLACK_BOX";
   
begin
   s(7 downto 1) <= s_DUMMY(7 downto 1);
   XLXI_5 : FDR
      port map (C=>clk, D=>s_DUMMY(1), R=>aspetta, Q=>s_DUMMY(2));
   
   XLXI_6 : FDP
      port map (C=>clk, D=>XLXN_14, PRE=>aspetta, Q=>s_DUMMY(1));
   
   XLXI_7 : FDR
      port map (C=>clk, D=>s_DUMMY(2), R=>aspetta, Q=>s_DUMMY(3));
   
   XLXI_8 : FDR
      port map (C=>clk, D=>s_DUMMY(3), R=>aspetta, Q=>s_DUMMY(4));
   
   XLXI_9 : FDR
      port map (C=>clk, D=>s_DUMMY(4), R=>aspetta, Q=>s_DUMMY(5));
   
   XLXI_10 : FDR
      port map (C=>clk, D=>s_DUMMY(5), R=>aspetta, Q=>s_DUMMY(6));
   
   XLXI_11 : FDR
      port map (C=>clk, D=>XLXN_13, R=>aspetta, Q=>s_DUMMY(7));
   
   XLXI_20 : OR2
      port map (I0=>s_DUMMY(7), I1=>s_DUMMY(6), O=>XLXN_13);
   
   XLXI_22 : GND
      port map (G=>XLXN_14);
   
end BEHAVIORAL;


