-- VHDL model created from flowlogic.sch - Mon Feb 25 16:08:50 2002


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity flowlogic is
   port ( aspetta  : in    std_logic; 
          clk      : in    std_logic; 
          clkIM    : out   std_logic; 
          clkRE    : out   std_logic; 
          clkr1    : out   std_logic; 
          clkr2    : out   std_logic; 
          inverti  : out   std_logic; 
          muxcoef  : out   std_logic; 
          muxdato1 : out   std_logic; 
          prendi   : out   std_logic);
end flowlogic;

architecture BEHAVIORAL of flowlogic is
   attribute BOX_TYPE   : STRING ;
   signal s        : std_logic_vector (7 downto 1);
   component OR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR2 : COMPONENT is "BLACK_BOX";
   
   component OR3
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             I2 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of OR3 : COMPONENT is "BLACK_BOX";
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : COMPONENT is "BLACK_BOX";
   
   component flow
      port ( aspetta : in    std_logic; 
             clk     : in    std_logic; 
             s       : out   std_logic_vector (7 downto 1));
   end component;
   
begin
   XLXI_2 : OR2
      port map (I0=>s(2), I1=>s(4), O=>muxcoef);
   
   XLXI_3 : OR3
      port map (I0=>s(2), I1=>s(5), I2=>s(6), O=>muxdato1);
   
   XLXI_5 : OR2
      port map (I0=>s(1), I1=>s(4), O=>clkr1);
   
   XLXI_6 : OR2
      port map (I0=>s(2), I1=>s(5), O=>clkr2);
   
   XLXI_23 : BUF
      port map (I=>s(2), O=>inverti);
   
   XLXI_27 : BUF
      port map (I=>s(3), O=>clkRE);
   
   XLXI_28 : BUF
      port map (I=>s(6), O=>clkIM);
   
   XLXI_29 : BUF
      port map (I=>s(7), O=>prendi);
   
   XLXI_30 : flow
      port map (aspetta=>aspetta, clk=>clk, s(7 downto 1)=>s(7 downto 1));
   
end BEHAVIORAL;


