-- VHDL model created from mpy9signed.sch - Mon Feb 25 16:06:30 2002


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity mpy9signed is
   port ( a       : in    std_logic_vector (8 downto 0); 
          b       : in    std_logic_vector (8 downto 0); 
          inverti : in    std_logic; 
          pos     : in    std_logic; 
          uscita  : out   std_logic_vector (8 downto 0));
end mpy9signed;

architecture BEHAVIORAL of mpy9signed is
   attribute BOX_TYPE   : STRING ;
   signal XLXN_1  : std_logic_vector (7 downto 0);
   signal XLXN_2  : std_logic_vector (7 downto 0);
   signal XLXN_3  : std_logic_vector (15 downto 0);
   signal XLXN_5  : std_logic;
   signal XLXN_6  : std_logic;
   signal XLXN_14 : std_logic;
   signal XLXN_16 : std_logic;
   signal XLXN_17 : std_logic;
   signal XLXN_20 : std_logic_vector (7 downto 0);
   signal XLXN_21 : std_logic;
   component signed2int23
      port ( a : in    std_logic_vector (8 downto 0); 
             b : in    std_logic_vector (8 downto 0); 
             e : out   std_logic; 
             f : out   std_logic; 
             c : out   std_logic_vector (7 downto 0); 
             d : out   std_logic_vector (7 downto 0));
   end component;
   
   component mpy9
      port ( a : in    std_logic_vector (7 downto 0); 
             b : in    std_logic_vector (7 downto 0); 
             c : out   std_logic_vector (15 downto 0));
   end component;
   
   component int2signed
      port ( f : in    std_logic; 
             a : in    std_logic_vector (7 downto 0); 
             b : out   std_logic_vector (8 downto 0));
   end component;
   
   component trunc9
      port ( a : in    std_logic_vector (15 downto 0); 
             b : out   std_logic_vector (7 downto 0));
   end component;
   
   component xormio
      port ( a : in    std_logic; 
             b : in    std_logic; 
             c : out   std_logic);
   end component;
   
   component AND2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of AND2 : COMPONENT is "BLACK_BOX";
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : COMPONENT is "BLACK_BOX";
   
   component XOR2
      port ( I0 : in    std_logic; 
             I1 : in    std_logic; 
             O  : out   std_logic);
   end component;
   attribute BOX_TYPE of XOR2 : COMPONENT is "BLACK_BOX";
   
begin
   XLXI_1 : signed2int23
      port map (a(8 downto 0)=>a(8 downto 0), b(8 downto 0)=>b(8 downto 0), c(7
            downto 0)=>XLXN_1(7 downto 0), d(7 downto 0)=>XLXN_2(7 downto 0),
            e=>XLXN_5, f=>XLXN_6);
   
   XLXI_2 : mpy9
      port map (a(7 downto 0)=>XLXN_1(7 downto 0), b(7 downto 0)=>XLXN_2(7
            downto 0), c(15 downto 0)=>XLXN_3(15 downto 0));
   
   XLXI_3 : int2signed
      port map (a(7 downto 0)=>XLXN_20(7 downto 0), f=>XLXN_21, b(8 downto
            0)=>uscita(8 downto 0));
   
   XLXI_4 : trunc9
      port map (a(15 downto 0)=>XLXN_3(15 downto 0), b(7 downto 0)=>XLXN_20(7
            downto 0));
   
   XLXI_6 : xormio
      port map (a=>XLXN_5, b=>XLXN_6, c=>XLXN_16);
   
   XLXI_7 : AND2
      port map (I0=>XLXN_14, I1=>XLXN_17, O=>XLXN_21);
   
   XLXI_8 : INV
      port map (I=>pos, O=>XLXN_14);
   
   XLXI_9 : XOR2
      port map (I0=>inverti, I1=>XLXN_16, O=>XLXN_17);
   
end BEHAVIORAL;


